package com.example.lfrmobileapp.ui.home;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import com.example.lfrmobileapp.Communication;
import com.example.lfrmobileapp.R;
import com.example.lfrmobileapp.databinding.FragmentManuellBinding;
import com.example.lfrmobileapp.ui.notifications.NotificationsFragment;

import io.github.controlwear.virtual.joystick.android.JoystickView;

public class HomeFragment extends Fragment {

    String ipKey = "ipkey";
    String portKey = "portkey";

    String ipAddress = "192.168.0.1";
    int port = 8000;

    private FragmentManuellBinding binding;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        HomeViewModel homeViewModel =
                new ViewModelProvider(this).get(HomeViewModel.class);

        binding = FragmentManuellBinding.inflate(inflater, container, false);
        View root = binding.getRoot();

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sharedPref.edit();

        ipAddress = sharedPref.getString(ipKey, "");
        port = sharedPref.getInt(portKey, 0);

        final TextView textView = binding.textHome;
        homeViewModel.getText().observe(getViewLifecycleOwner(), textView::setText);

        JoystickView joystick = (JoystickView) binding.joystick;
        Communication com = new Communication();
        joystick.setOnMoveListener(new JoystickView.OnMoveListener() {
            @Override
            public void onMove(int angle, int strength) {
                homeViewModel.setText(Integer.toString(angle), Integer.toString(strength));
                if((angle >= 338 || angle < 22) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.right);
                }else if((angle >= 22 && angle < 67) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.right_forward);
                }else if((angle >=67 && angle < 112) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.forward);
                }else if((angle >=112 && angle < 157) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.left_forward);
                }else if((angle >=157 && angle < 202) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.left);
                }else if((angle >=202 && angle < 247) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.left_back);
                }else if((angle >=247 && angle < 292) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.back);
                }else if((angle >=292 && angle < 337) && strength != 0){
                    joystick.setBackgroundResource(R.mipmap.right_back);
                }
                else{
                    joystick.setBackgroundResource(R.mipmap.blank);
                }

                com.sendData("Vanessa stinkt, Baran nicht", ipAddress, port);
            }
        });

        return root;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }


}