package com.example.lfrmobileapp.ui.notifications;

import android.app.Activity;
import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.ViewModelProvider;

import com.example.lfrmobileapp.Communication;
import com.example.lfrmobileapp.R;
import com.example.lfrmobileapp.databinding.FragmentEinstellungenBinding;


public class NotificationsFragment extends Fragment {

    String ipKey = "ipkey";
    String portKey = "portkey";
    String connectionFailed = "Verbindung fehlgeschlagen.";
    String connectionSuccessful = "Verbindung erfolgreich.";

    String ipAddress = "192.168.0.1";
    int port = 8000;

    int duration = Toast.LENGTH_LONG;

    private FragmentEinstellungenBinding binding;

    public View onCreateView(@NonNull LayoutInflater inflater,
                             ViewGroup container, Bundle savedInstanceState) {
        NotificationsViewModel notificationsViewModel =
                new ViewModelProvider(this).get(NotificationsViewModel.class);

        binding = FragmentEinstellungenBinding.inflate(inflater, container, false);
        View root = binding.getRoot();

        Communication com = new Communication();

        SharedPreferences sharedPref = getActivity().getPreferences(Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = sharedPref.edit();

        ipAddress = sharedPref.getString(ipKey, "");
        binding.ipAdress.setText(ipAddress);
        port = sharedPref.getInt(portKey, -1);
        if(port != -1){
            binding.port.setText(Integer.toString(port));
        }else{
            binding.port.setText("");
        }


        final Button button = binding.connect;
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                ipAddress = String.valueOf(binding.ipAdress.getText());
                port = Integer.parseInt(String.valueOf(binding.port.getText()));
                if(com.sendData("", ipAddress, port)){
                    editor.putString(ipKey, ipAddress);
                    editor.putInt(portKey, port);
                    editor.apply();
                    Toast toast = Toast.makeText(v.getContext(), connectionSuccessful, duration);
                    toast.show();
                }else{
                    Toast toast = Toast.makeText(v.getContext(), connectionFailed, duration);
                    toast.show();
                }
            }
        });


        return root;
    }

    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }
}